routes/web.php
<?php

use App\Http\Controllers\Admin\AdminPagesController;
use App\Http\Controllers\Admin\CarsController;
use App\Http\Controllers\Admin\ArticlesController;
use App\Http\Controllers\ArticlesController as BaseArticles;
use App\Http\Controllers\BasketController;
use App\Http\Controllers\CallbackController;
use App\Http\Controllers\CatalogController;
use App\Http\Controllers\Manager\ManagerPagesController;
use App\Http\Controllers\OrdersController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SalonsController;
use App\Http\Controllers\ServiceController;
use App\Http\Controllers\TestDriveController;
use Illuminate\Routing\Router;
use Illuminate\Support\Facades\Route;

Route::get('/', [PagesController::class, 'homepage'])->name('home');

Route::get('/about', [PagesController::class, 'about'])->name('about');

Route::get('/catalog/{slug?}', [CatalogController::class, 'catalog'])->name('catalog');
Route::get('/products/{car:id}', [CatalogController::class, 'product'])->name('product');

Route::get('/salons', [SalonsController::class, 'index'])->name('salons.index');

Route::get('/basket', [BasketController::class, 'show'])->name('basket');
Route::post('/basket', [BasketController::class, 'addProduct'])->name('basket.addProduct');
Route::delete('/basket/deleteProduct/', [BasketController::class, 'deleteProduct'])->name('basket.deleteProduct');
Route::delete('/basket/removeProduct', [BasketController::class, 'removeProduct'])->name('basket.removeProduct');

Route::get('/callback', [CallbackController::class, 'show'])->name('callback.show');
Route::post('/callback', [CallbackController::class, 'store'])->name('callback.store');
Route::post('/callback/{id}', [CallbackController::class, 'update'])->name('callback.update');

Route::get('/test-drive', [TestDriveController::class, 'show'])->name('test-drive.show');
Route::post('/test-drive', [TestDriveController::class, 'store'])->name('test-drive.store');

Route::get('/service', [ServiceController::class, 'show'])->name('service.show');

Route::middleware('auth')->group(function () {
    Route::get('/basket', [BasketController::class, 'show'])->name('basket');
    Route::post('/basket', [BasketController::class, 'addProduct'])->name('basket.addProduct');
    Route::delete('/basket/deleteProduct/', [BasketController::class, 'deleteProduct'])->name('basket.deleteProduct');
    Route::delete('/basket/removeProduct', [BasketController::class, 'removeProduct'])->name('basket.removeProduct');
});

Route::get('/articles', [BaseArticles::class, 'index'])->name('articles.index');
Route::get('/articles/{slug}', [BaseArticles::class, 'show'])->name('articles.show');

Route::prefix('admin')
    ->name('admin.')
    ->middleware(['auth', 'role:admin'])
    ->group(function (Router $router) {
        $router->get('/', [AdminPagesController::class, 'admin'])->name('admin');
        $router->resource('cars', CarsController::class)->except(['show']);
        $router->resource('articles', ArticlesController::class)->except(['show']);
    })
;

Route::prefix('test-drive')
    ->name('manager.test-drive.')
    ->middleware(['auth', 'role:manager'])
    ->group(function (Router $router) {
        $router->post('/{id}', [TestDriveController::class, 'update'])->name('update');
        $router->get('/{id}/edit', [TestDriveController::class, 'edit'])->name('edit');
        $router->delete('/{id}', [TestDriveController::class, 'destroy'])->name('destroy');
    })
;

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
    Route::post('/profile/orders', [OrdersController::class, 'store'])->name('orders.create');
});

Route::prefix('manager')
    ->name('manager.')
    ->middleware(['auth', 'role:manager'])
    ->group(function (Router $router) {
        $router->get('/', [ManagerPagesController::class, 'manager'])->name('manager');
    })
;

require __DIR__.'/auth.php';

app/Models/TestDrive.php
<?php

namespace App\Models;

use App\Contracts\HasTagsContract;
use App\Enums\CallbackStatus;
use App\Enums\ModelStatus;
use Illuminate\Contracts\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\HasOne;
use Illuminate\Database\Eloquent\Relations\MorphToMany;
use Illuminate\Database\Eloquent\SoftDeletes;

class TestDrive extends Model
{
    use HasFactory;
    use SoftDeletes;

    protected $fillable = ['client_name', 'client_phone', 'more_info', 'status', 'car_id', 'salon_id'];

    public function car(): BelongsTo
    {
        return $this->belongsTo(Car::class);
    }

    public function salon(): BelongsTo
    {
        return $this->belongsTo(Salon::class);
    }
}

app/Http/Controllers/Manager/ManagerPagesController.php
<?php

namespace App\Http\Controllers\Manager;

use App\Contracts\Repositories\CallbacksRepositoryContract;
use App\Contracts\Repositories\OrdersRepositoryContract;
use App\Contracts\Repositories\TestDrivesRepositoryContract;
use App\Http\Controllers\Controller;
use Illuminate\View\View;

class ManagerPagesController extends Controller
{
    public function manager(
        OrdersRepositoryContract $ordersRepository,
        CallbacksRepositoryContract $callbacksRepository,
        TestDrivesRepositoryContract $testDrivesRepository
    ): View {
        $orders = $ordersRepository->findAll(['user']);
        $callbacks = $callbacksRepository->findAll();
        $testDrives = $testDrivesRepository->findAll();

        return view('pages.manager.manager-panel', compact('orders', 'callbacks', 'testDrives'));
    }
}

app/Http/Controllers/TestDriveController.php
<?php

namespace App\Http\Controllers;

use App\Contracts\Repositories\CarsRepositoryContract;
use App\Contracts\Repositories\TestDrivesRepositoryContract;
use App\Contracts\Services\FlashMessageContract;
use App\Contracts\Services\TestDrives\TestDrivesCreationServiceContract;
use App\Contracts\Services\TestDrives\TestDrivesRemoverServiceContract;
use App\Contracts\Services\TestDrives\TestDrivesUpdateServiceContract;
use App\Http\Requests\ClientRequests\TestDriveRequest;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\View\View;

class TestDriveController extends Controller
{
    public function show(
        CarsRepositoryContract $carsRepository,
        TestDrivesRepositoryContract $testDrivesRepository
    ): View {
        return view('pages.test-drive', [
            'cars' => $carsRepository->findAvailableAtSalons(['salons', 'image']),
            'testDrive' => $testDrivesRepository->getModel()
        ]);
    }

    public function store(
        TestDriveRequest $request,
        TestDrivesCreationServiceContract $testDrivesService,
        FlashMessageContract $flashMessage
    ): RedirectResponse {
        $testDrivesService->create($request->validated());
        $flashMessage->success('Ваша заявка сформирована. В ближайшее время мы с Вами свяжемся');
        return back();
    }

    public function update(
        TestDriveRequest $request,
        TestDrivesUpdateServiceContract $testDrivesService,
        FlashMessageContract $flashMessage
    ): RedirectResponse {
        $fields = $request->validated();
        $testDrivesService->update($fields['id'], [
            'salon_id' => $fields['salon_id'],
            'car_id' => $fields['car_id'],
            'client_name' => $fields['client_name'],
            'client_phone' => $fields['client_phone'],
            'more_info' => $fields['more_info'] ?? '',
            'status' => $fields['status'] ?? ''
        ]);

        $flashMessage->success('Заявка успешно обновлена');
        return back();
    }

    public function edit(
        Request $request,
        TestDrivesRepositoryContract $testDrivesRepository
    ): View {
        return view('pages.manager.test-drives.element-edit', ['testDrive' => $testDrivesRepository->findById($request->id, ['car.salons', 'salon'])]);
    }

    public function destroy(
        Request $request,
        FlashMessageContract $flashMessage,
        TestDrivesRemoverServiceContract $testDrivesService
    ): RedirectResponse {
        $testDrivesService->delete($request->id);
        $flashMessage->success('Заявка удалена');
        return back();
    }
}

resources/views/pages/manager/test-drives/element-edit.blade.php
<x-layouts.admin
    page-title="Форма редактирования заявки на тест-драйв"
    title="Форма редактирования заявки на тест-драйв"
>
    <x-forms.form action="{{ route('manager.test-drive.update', $testDrive->id) }}" method="post" enctype="multipart/form-data">
        @method('POST')

        <x-forms.concrete-forms-fields.manager-testdrive-form-fields :testDrive="$testDrive" />

        <x-forms.row>
            <x-forms.submit-button>
                Сохранить
            </x-forms.submit-button>
            <x-forms.cancel-button href="{{ route('manager.test-drive.edit', $testDrive->id) }}">
                Отменить
            </x-forms.cancel-button>
        </x-forms.row>
    </x-forms.form>
</x-layouts.admin>

resources/views/pages/manager/test-drives/element.blade.php
<tr class="bg-white border-b  hover:bg-gray-100">
    <td class="px-6 py-4 font-semibold text-gray-900">
        {{ $testDrive->id }}
    </td>
    <td class="px-6 py-4 font-semibold text-gray-900">
        {{ $testDrive->client_name }}
    </td>
    <td class="px-6 py-4 font-semibold text-gray-900">
        {{ $testDrive->client_phone }}
    </td>
    <td class="px-6 py-4 font-semibold text-gray-900">
        {{ $testDrive->more_info }}
    </td>
    <td class="px-6 py-4 font-semibold text-gray-900">
        <a class="hover:text-orange text-black" href="{{ route('product', $testDrive->car->id) }}">{{ $testDrive->car->name}}</a>
    </td>
    <td class="px-6 py-4 font-semibold text-gray-900">
        {{ $testDrive->salon->name }}
    </td>
    <td class="px-4 py-2">
        <div class="flex items-center">
            <a href="{{ route('manager.test-drive.edit', $testDrive->id) }}" class="inline-block bg-orange hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Редактировать">
                <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" viewBox="0 0 20 20" fill="currentColor">
                    <path d="M17.414 2.586a2 2 0 00-2.828 0L7 10.172V13h2.828l7.586-7.586a2 2 0 000-2.828z" />
                    <path fill-rule="evenodd" d="M2 6a2 2 0 012-2h4a1 1 0 010 2H4v10h10v-4a1 1 0 112 0v4a2 2 0 01-2 2H4a2 2 0 01-2-2V6z" clip-rule="evenodd" />
                </svg>
            </a>
        </div>
    </td>
    <td class="px-4 py-2">
        <form class="flex items-center" action="{{ route('manager.test-drive.destroy', $testDrive->id) }}" method="post">
            @csrf
            @method('DELETE')
            <button class="inline-block bg-gray-400 hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Удалить" onclick="return confirm('вы уверены, что хотите удалить эту заявку?')">
                <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
                    <path stroke-linecap="round" stroke-linejoin="round" d="M19 7l-.867 12.142A2 2 0 0116.138 21H7.862a2 2 0 01-1.995-1.858L5 7m5 4v6m4-6v6m1-10V4a1 1 0 00-1-1h-4a1 1 0 00-1 1v3M4 7h16" />
                </svg>
            </button>
        </form>
    </td>
</tr>

resources/views/pages/manager/test-drives/list.blade.php
<header>
    <h2 class="text-lg font-medium text-gray-900">
        {{ __('Список запросов на тест-драйв') }}
    </h2>
</header>
@if($testDrives->isEmpty())
    <x-panels.empty-section>
        Нет запросов
    </x-panels.empty-section>
@else
    <div class="pt-6 relative overflow-x-auto shadow-md sm:rounded-lg">
        @include('pages.manager.test-drives.table', ['testDrives' => $testDrives])
    </div>
@endif

resources/views/pages/manager/test-drives/table.blade.php
<table class="w-full text-sm text-left text-black">
    <thead class="text-xs uppercase border-2">
    <tr>
        <th scope="col" class="px-6 py-3 font-bold">
            Номер запроса
        </th>
        <th scope="col" class="px-6 py-3 font-bold">
            Имя клиента
        </th>
        <th scope="col" class="px-6 py-3 font-bold">
            Телефон клиента
        </th>
        <th scope="col" class="px-6 py-3 font-bold">
            Дополнительная информация
        </th>
        <th scope="col" class="px-6 py-3 font-bold">
            Модель
        </th>
        <th scope="col" class="px-6 py-3 font-bold">
            Салон
        </th>
        <th scope="col" class="px-6 py-3 font-bold">

        </th>
        <th scope="col" class="px-6 py-3 font-bold">

        </th>
    </tr>
    </thead>
    <tbody>
    @foreach($testDrives as $testDrive)
        @include('pages.manager.test-drives.element', ['testDrive' => $testDrive])
    @endforeach
    </tbody>
</table>